<script lang="ts">
    import { postUserProfileAPI } from "src/apis/register-user";
    import { facebookAuthStore, userFormRegisStore } from "src/store";
    import DatePicker from "src/widgets/DatePicker.svelte";
    import UploadImage from "src/widgets/UploadImage.svelte";
    import { createForm } from "svelte-forms-lib";
    import * as yup from "yup";
    import { verifyUserIdExistsAPI } from "src/apis/verify-userId-exists";
    import { verifyEmailExistsAPI } from "src/apis/verify-email-exists";
    import AlertMessage from "src/widgets/AlertMessage";

    let newPassword = "";
    let confPassword = "";
    let userIdAlreadyExists = false;
    let emailAlreadyExists = false;
    let intrvalInput: any;

    $: password = newPassword === confPassword ? newPassword : "";

    const phoneRegExp = /^((\\+[1-9]{1,4}[ \\-]*)|(\\([0-9]{2,3}\\)[ \\-]*)|([0-9]{2,4})[ \\-]*)*?[0-9]{3,4}?[ \\-]*[0-9]{3,4}?$/;

    const { form, errors, state, handleChange, handleSubmit } = createForm({
        initialValues: {
            userId: Object.values($facebookAuthStore || {}).length
                ? $facebookAuthStore.id
                : "",
            loginBy: Object.values($facebookAuthStore || {}).length
                ? "facebook"
                : "app",
            fname: "",
            lname: "",
            pass: "",
            birth: "",
            sex: "",
            address: [],
            image: Object.values($facebookAuthStore || {}).length
                ? $facebookAuthStore.imgProfile
                : "",
            telNo: "",
            email: Object.values($facebookAuthStore || {}).length
                ? $facebookAuthStore.email || ""
                : "",
            status: "active"
        },
        validationSchema: yup.object().shape({
            userId: yup.string().required(),
            fname: yup.string().required(),
            loginBy: yup.string().required(),
            pass: yup.string().required(),
            lname: yup.string().required(),
            birth: yup.string().required(),
            sex: yup.string().required(),
            image: yup.string().required(),
            telNo: yup
                .string()
                .matches(phoneRegExp, "Phone number is not valid")
                .required(),
            email: yup.string().email().required(),
        }),
        validate: (values) => {
            let errs: any = {};
            if (password) {
                values.pass = password;
            }
            if (values.userId == "") {
                errs["userId"] = "userId is required";
            }
            if (values.fname === "") {
                errs["fname"] = "Firstname is required";
            }
            if (values.lname === "") {
                errs["lname"] = "Lastname is required";
            }

            if ($form.loginBy != "facebook") {
                if (
                    newPassword !== confPassword ||
                    newPassword === "" ||
                    confPassword === ""
                ) {
                    errs["pass"] = "Password not match or Not Input";
                }
            }
            if (values.email === "") {
                errs["email"] = "Email is required";
            }
            if (values.sex === "") {
                errs["sex"] = "sex is required";
            }
            if (values.telNo === "") {
                errs["telNo"] = "phone is required";
            }

            if (values.birth === "") {
                errs["birth"] = "Input Birth Date";
            }

            if (userIdAlreadyExists == true) {
                errs["userId"] = "UserId Already exists";
            }

            if (emailAlreadyExists == true) {
                errs["email"] = "Email Already exists";
            }
            return errs;
        },
        onSubmit: (values) => {
            $userFormRegisStore = values;
            postUserProfileAPI($userFormRegisStore).then((resp) => {
                AlertMessage.alert("สมัครสมาชิกเสร็จแล้ว").then((resp) => {
                    (window as any).location.reload();
                });
            });
        },
    });

    async function verifyUserId() {
        clearInterval(intrvalInput);
        intrvalInput = setTimeout(async () => {
            const userProfile = await verifyUserIdExistsAPI($form.userId);
            userIdAlreadyExists = Object.values(userProfile).length > 0;
        }, 1000);
    }

    async function verifyEmail() {
        clearInterval(intrvalInput);
        intrvalInput = setTimeout(async () => {
            const userProfile = await verifyEmailExistsAPI($form.email);
            emailAlreadyExists = Object.values(userProfile).length > 0;
        }, 1000);
    }
</script>

<div class="mx-auto my-5 rounded bg-white px-5">
    <form on:submit={handleSubmit}>
        <div
            class="flex overflow-visible flex-col px-8 pt-0 pb-5 leading-4 text-gray-800"
        >
            <div class="flex items-start pt-8 text-gray-800">
                <p class="text-red-500">* กรุณากรอกข้อมูลเพื่อสมัครสมาชิก</p>
            </div>
            <div class="flex items-start pt-8 text-gray-800">
                <div class="flex-1 pr-12">
                    <div class="mb-8">
                        <div class="flex justify-end items-center">
                            <div
                                class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                            >
                                <label class="capitalize cursor-default"
                                    >เข้าด้วย</label
                                >
                            </div>
                            <div class="pl-5 w-4/5 box-border">
                                <p
                                    class="px-2 py-2 bg-blue-500 text-white rounded-full text-center"
                                >
                                    {$form.loginBy}
                                </p>
                            </div>
                        </div>
                    </div>
                    <div class="mb-8">
                        <div class="flex justify-end items-center">
                            <div
                                class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                            >
                                <label class="capitalize cursor-default"
                                    >ไอดีผู้ใช้</label
                                >
                            </div>
                            <div class="pl-5 w-4/5 box-border">
                                <input
                                    type="text"
                                    placeholder="แนะนำภาษาอังกฤษและตัวเลข"
                                    maxlength="100"
                                    readonly={Object.values(
                                        $facebookAuthStore || {}
                                    ).length > 0}
                                    id="userId"
                                    name="userId"
                                    on:change={handleChange}
                                    on:keydown={verifyUserId}
                                    bind:value={$form.userId}
                                    class:border-red-500={$errors["userId"]}
                                    class="flex relative items-center p-2 h-10 text-gray-900 rounded-sm border border-gray-400 border-solid box-border shadow-xs hover:shadow-xs w-full"
                                />
                                {#if userIdAlreadyExists}
                                    <p class="text-red-500 py-5">
                                        * ไอดีนี้มีผู้ใช้แล้วต้องเปลี่ยนใหม่
                                    </p>
                                {/if}
                            </div>
                        </div>
                    </div>
                    <div class="mb-8">
                        <div class="flex justify-end items-center">
                            <div
                                class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                            >
                                <label class="capitalize cursor-default"
                                    >ชื่อ</label
                                >
                            </div>
                            <div class="pl-5 w-4/5 box-border">
                                <input
                                    type="text"
                                    placeholder=""
                                    maxlength="100"
                                    id="fname"
                                    name="fname"
                                    on:change={handleChange}
                                    bind:value={$form.fname}
                                    class:border-red-500={$errors["fname"]}
                                    class="flex relative items-center p-2 h-10 text-gray-900 rounded-sm border shadow-xs hover:shadow-xs w-full"
                                />
                            </div>
                        </div>
                    </div>
                    <div class="mb-8">
                        <div class="flex justify-end items-center">
                            <div
                                class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                            >
                                <label class="capitalize cursor-default"
                                    >สกุล</label
                                >
                            </div>
                            <div class="pl-5 w-4/5 box-border">
                                <input
                                    type="text"
                                    placeholder=""
                                    maxlength="100"
                                    id="lname"
                                    name="lname"
                                    on:change={handleChange}
                                    bind:value={$form.lname}
                                    class:border-red-500={$errors["lname"]}
                                    class="flex relative items-center p-2 h-10 text-gray-900 rounded-sm border border-gray-400 border-solid box-border shadow-xs hover:shadow-xs w-full"
                                />
                            </div>
                        </div>
                    </div>
                    {#if $form.loginBy != "facebook"}
                        <div class="mb-8">
                            <div class="flex justify-end items-center">
                                <div
                                    class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                                >
                                    <label class="capitalize cursor-default"
                                        >รหัสผ่าน</label
                                    >
                                </div>
                                <div class="pl-5 w-4/5 box-border">
                                    <input
                                        type="password"
                                        placeholder=""
                                        maxlength="40"
                                        id="password"
                                        name="password"
                                        bind:value={newPassword}
                                        class:border-red-500={newPassword !==
                                            confPassword ||
                                            newPassword === "" ||
                                            confPassword === ""}
                                        class="flex relative items-center p-2 h-10 text-gray-900 rounded-sm border border-gray-400 border-solid box-border shadow-xs hover:shadow-xs w-full"
                                    />
                                </div>
                            </div>
                        </div>
                        <div class="mb-8">
                            <div class="flex justify-end items-center">
                                <div
                                    class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                                >
                                    <label class="capitalize cursor-default"
                                        >ยืนยันรหัสผ่าน</label
                                    >
                                </div>
                                <div class="pl-5 w-4/5 box-border">
                                    <input
                                        type="password"
                                        placeholder=""
                                        maxlength="40"
                                        id="conf_pass"
                                        name="conf_pass"
                                        bind:value={confPassword}
                                        class:border-red-500={newPassword !==
                                            confPassword ||
                                            newPassword === "" ||
                                            confPassword === ""}
                                        class="flex relative items-center p-2 h-10 text-gray-900 rounded-sm border border-gray-400 border-solid box-border shadow-xs hover:shadow-xs w-full"
                                    />
                                    {#if $errors["pass"]}
                                        <p class="text-red-500">
                                            {$errors["pass"]}
                                        </p>
                                    {/if}
                                </div>
                            </div>
                        </div>
                    {/if}
                    <div class="mb-8">
                        <div class="flex justify-end items-center">
                            <div
                                class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                            >
                                <label class="capitalize cursor-default"
                                    >Email</label
                                >
                            </div>
                            <div class="pl-5 w-4/5 box-border">
                                <div class="flex items-center">
                                    <input
                                        type="text"
                                        placeholder=""
                                        maxlength="255"
                                        id="email"
                                        name="email"
                                        on:change={handleChange}
                                        on:keydown={verifyEmail}
                                        bind:value={$form.email}
                                        class:border-red-500={$errors["email"]}
                                        class="flex relative items-center p-2 h-10 text-gray-900 rounded-sm border border-gray-400 border-solid box-border shadow-xs hover:shadow-xs w-full"
                                    />
                                </div>
                                {#if emailAlreadyExists}
                                    <p class="text-red-500 py-5">
                                        * อีเมลล์นี้มีผู้ใช้แล้วต้องเปลี่ยนใหม่
                                    </p>
                                {/if}
                            </div>
                        </div>
                    </div>
                    <div class="mb-8">
                        <div class="flex justify-end items-center">
                            <div
                                class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                            >
                                <label class="capitalize cursor-default"
                                    >หมายเลขโทรศัพท์</label
                                >
                            </div>
                            <div class="pl-5 w-4/5 box-border">
                                <div class="flex items-center">
                                    <input
                                        type="text"
                                        placeholder=""
                                        maxlength="10"
                                        id="telNo"
                                        name="telNo"
                                        on:change={handleChange}
                                        bind:value={$form.telNo}
                                        class:border-red-500={$errors["telNo"]}
                                        class="flex relative items-center p-2 h-10 text-gray-900 rounded-sm border border-gray-400 border-solid box-border shadow-xs hover:shadow-xs w-full"
                                    />
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mb-8">
                        <div class="flex justify-end items-center">
                            <div
                                class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                            >
                                <label class="capitalize cursor-default"
                                    >เพศ</label
                                >
                            </div>
                            <div class="pl-5 w-4/5 box-border">
                                <div
                                    class="border border-transparent"
                                    class:border-red-500={$errors["telNo"]}
                                >
                                    <div class="flex">
                                        <label for="male" class="px-5">
                                            <span class="">
                                                <input
                                                    id="male"
                                                    value="male"
                                                    bind:group={$form.sex}
                                                    type="radio"
                                                    class=""
                                                />
                                            </span>
                                            <span class="">ชาย</span>
                                        </label>
                                        <label for="female" class="px-5">
                                            <span class="">
                                                <input
                                                    id="female"
                                                    value="female"
                                                    bind:group={$form.sex}
                                                    type="radio"
                                                    class=""
                                                />
                                            </span>
                                            <span class="">หญิง</span>
                                        </label>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="mb-8">
                        <div class="flex justify-end items-center">
                            <div
                                class="overflow-hidden w-1/5 text-right text-gray-600 capitalize"
                            >
                                <label class="capitalize cursor-default"
                                    >ว/ด/ป</label
                                >
                            </div>
                            <div class="pl-5 w-4/5 flex flex-col">
                                <DatePicker bind:value={$form.birth} />
                                {#if $errors["birth"]}
                                    <p class="text-red-500">
                                        {$errors["birth"]}
                                    </p>
                                {/if}
                            </div>
                        </div>
                    </div>
                </div>
                <div class="flex overflow-hidden justify-center w-64">
                    <div class="flex flex-col items-center">
                        <div
                            class="flex relative justify-center items-center my-5 mx-0 w-24 h-24 border border-transparent"
                        >
                            <UploadImage bind:value={$form.image} />
                        </div>
                        <div class="block mt-3">
                            <div class="text-sm leading-5 text-gray-500">
                                กดที่ภาพเพื่อเปลี่ยนรูปประจำตัว
                            </div>
                            <div class="text-sm leading-5 text-gray-500">
                                ไฟล์ที่รองรับ: .JPEG, .PNG
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="w-full flex justify-end flex-col items-end">
            <div class="mb-16">
                <button
                    type="submit"
                    class="inline-flex overflow-hidden flex-col justify-center items-center py-0 px-5 m-0 h-10 text-sm text-center text-white capitalize bg-red-600 rounded-sm border-0 cursor-pointer box-border shadow-xs hover:bg-red-600 focus:bg-red-600 focus:shadow-xs"
                    aria-disabled="false"
                    style="text-overflow: ellipsis; outline: 0px; min-width: 70px; max-width: 220px;"
                >
                    บันทึก
                </button>
            </div>
        </div>
    </form>
</div>
